<?php
/*
 * Our index file.
 *
 * PHP version 5
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the Affero General Public License as published by Affero Inc.,
 * either version 1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful to the Free
 * Software community, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the Affero
 * General Public License for more details.
 * 
 * You should have received a copy of the Affero General Public License with this
 * software in the ./AfferoGPL file; if not, write to Affero Inc., 510 Third Street,
 * Suite 225, San Francisco, CA 94107, USA
 *
 * @category   Public Controller
 * @author     Klaus Weiss <klaus.weiss@nanet.at>
 * @copyright  2007 GNU Herds Free Software Association
 * @license    http://www.affero.org/oagpl.html Affero GPL
 * @version    CVS: $Id:$
 * @since      File available since version 1.5
 */

define('VISIBLE', true);

define('ROOT', dirname(__FILE__));

require_once(ROOT.'/../../include/dep.inc.php');
require_once(ROOT.'/../../core/controller.class.php');


$array = split(SITE_URL_SEPARATOR, $HTTP_SERVER_VARS['PATH_INFO']);

$controller = $array[1];

$cntr_file = ROOT.'/../../site/controller/'.$controller.'.php';;

if(!file_exists($cntr_file))
{
  show_error_site(ERROR_NO_CONTROLLER);
}

require_once($cntr_file);

$controller = $controller.'Controller';

if(!class_exists($controller))
{
  show_error_site(ERROR_NO_CONTROLLER);
}

$cntr = new $controller;

$action = $array[2];

if(!method_exists($cntr, $action))
{
  show_error_site(ERROR_NO_ACTION);
}

$params = array();
for($i = 3; $i < count($array); $i += 2)
{
  if(!$array[$i+1])
    continue;
  
  $params[$array[$i]] = $array[$i+1];
}

unset($i);
unset($array);

if(array_key_exists('lang', $params) and !empty($params['lang']))
{
  $k = array_search($params['lang'], Controller::$AVAILABLE_LANGS);

  if($k !== false)
    {
      Controller::_setLanguage($params['lang']);
      $cntr->set('pageLanguage', $params['lang']);
    }
  else
    {
      Controller::_setLanguage(LOCALE_STANDARD);
      $cntr->set('pageLanguage', LOCALE_STANDARD);
    }
}
else
{
  Controller::_setLanguage(Controller::_getPreferredLanguage());
  $cntr->set('pageLanguage', Controller::_getPreferredLanguage());
}


$cntr->data['GET'] = $params;

foreach($_REQUEST as $k => $v)
{
  $array = split('/', $k);

  if(!is_model($array[1]))
    {
      show_error_site(ERROR_NO_MODEL);
    }

  $model = $array[1];
  $field = $array[2];

  $cntr->data[$model][$field] = $v;
}

foreach($cntr->model as $model)
{
  foreach($model->validate as $k => $v)
    {
      if(array_key_exists($model->name, $cntr->data))
	{
	  if(!preg_match($v, $cntr->data[$model->name][$k]))
	    {
	      $mField = '/'.$model->name.'/'.$k;
	      
	      $cntr->triggeredFormErrors[$mField] = false;
	      $cntr->data[$model->name][$k] = false;
	    }
	}
    }
}

     
$cntr->beforeRender();

ob_start();
$cntr->$action();
$cntr_content = ob_get_contents();
ob_end_clean();

$cntr->set('pageTitle', $cntr->pageTitle);

$s_cntr = str_replace('Controller', '', $controller);
foreach($params as $k => $v)
{
  $s_params .= $k.'/'.$v;
}

$cntr->set('pageCLink', SITE_URL.'/index.php/'.$s_cntr.'/'.$action.'/'.$s_params);

$cntr->view->render($action);

$cntr->afterRender();

if(SITE_DEBUG)
{
  echo $cntr_content;
}

?>